Changelog
------------------------------------------------------------------------------------
3.1
 - Decoder upgraded to version 3.1
	- Added support for three additional Code 25 variants: Matrix, COOP, and Inverted
	- Added support for MaxiCode symbology
	- Added support for Micro QR symbology
	- Added support for POSTNET, PLANET, IMB, and Royal Mail postal codes
	- Added support for Kanji for both Standard and Micro QR codes
	- Added support for GS1 DotCode
	- Added Structured Carrier Message (MaxiCode) to Parser Plugin.
	- Greatly improved decoding performance for low-light or unevenly lit barcodes
	- Improved Direct Part Marking (DPM) detection for Data Matrix barcodes
	- Improved performance of the PDF417 decoder
	- Improved performance of the Data Matrix decoder
	- Improved performance for Code 25 detection

3.0
 - The registration functions have been revamped. License credentials issued prior to version 3.0 will no longer work with this and future releases. The old function for registration call was 
“Scanner.MWBregisterCode(BARCODE_MASK, "username", "key")”
Now a new function for registration calls has been implemented containing only a variable for license keys, discontinuing the need for “username”: 
	“Scanner.MWBregisterSDK("key");”
 - UPC/EAN decoder options now support a flag to disable add-on scanning
 - A function was added to prevent duplicate barcode detection within a given time period
 - Barcode location support has been implemented for 1D barcodes (Codabar, Code 25, Code 39, Code 93, Code 128, EAN & UPC) - not enabled by default, can be activated by using BarcodeScanner.MWBsetFlags(0, MWB_CFG_GLOBAL_CALCULATE_1D_LOCATION)
 - PDF417 decoding has improved damage resistance making it easier to scan damaged codes
 - Greatly improved the recognition of dotted Data Matrix 
 - Rectangular Data Matrix codes with DMRE extension now supported
 - Better recognition of Code 39 stop pattern


2.2
- Windows 10 desktop/tablet/mobile support
- Added buttons for zoom and flash in the mobile version
- Added dropbox for choosing camera resolution for the desktop/tablet version
- Added OVERLAY_MODE flag with the following options:
    - MW_OVERLAY     - Use MW dynamic viewfinder with blinking line
    - OM_IMAGE               - Use image file as overlay (overlay.png)
    - OM_NONE                - Don't display any overlay

2.1
- Added Manatee Works Parser SDK (beta) integration; This feature is optional. Use of the Parser SDK enables rapid interpretation of barcode decoding results of various formatting standards, such as: IUID, AAMVA, ISBT, HIBC and GS1 . More information about the Parser SDK can be found here: https://manateeworks.com/parser
- Added Manatee Works Analytics SDK (beta) integration; This feature is optional. Use of the Analytics SDK enables real-time insights into end-user scan activity. More information about the Analytics SDK can be found here: https://manateeworks.com/analytics
- Decoder SDK updated to 2.10.2

2.0
- The decoding process is now thread-safe; Multithreading is enabled by default for using all available cpu cores on a device. You can change the value of the parameter named MAX_THREADS to 1 in order to disable multi-threading, or you can specify the number of simultaneous threads, but they should never exceed the maximum number of CPU cores on a device (retrieved with host_basic_info_data_t.max_cpus) or the performance may decrease substantially.
- In order to use multithreaded decoding, a new type of result should be used: 

    MWBsetResultType(MWB_RESULT_TYPE_MW)

More about multi-threading can be found in the following notes - https://manateeworks.com/news/2015/01/multi-thread-safety-feature-release-notes

How to add the Barcode Scanner SDK to the user applications:
------------------------------------------------------------------------------------
1. Open package.appxmanifest file, go to the capabilities tab, Microphone and Webcam capabilities need to be checked.
2. Right click on the created project, under the Build tab, check the "Allow unsafe code"(This will need to be done for desktop/tablet/mobile architecture).
3. Copy files from project folder, and add code files to the project as existing files:
- BarcodeHelper.cs
- MWOverlay.cs
- ScannerPage.xaml
- ScannerPage.xaml.cs
- WinRT folder 
4. Copy all files from Resources folder (with copy items if needed checked)
5. Install MWBarcodeLibUniversalSDK.vsix plugin (this will install the barcode lib on right place)
6. Add references (if not already in project):
     - Manateeworks BarcodeLib Universal SDK for Windows Store 10.0 (added after previous plugin install)
     - Windows mobile extension for the UWP
     - WritabbleBitmapEx.WinRT (When you add a reference, click browse, go to project home folder, then in WinRT, and select WritabbleBitmapEx.dll)
7. Add a button in the mainPage.xaml.
	 - Double click on the created button to creat onClick method.
	 - Call the scanner with using this.Frame.Navigate(typeof(ScannerPage)); (eg. on button click).
8. Add "using MWBCameraDemo" in page from which you are calling the scanner.
