// cppDemo.cpp : main project file.

#include "stdafx.h"
#include "BarcodeScanner.h"
#include "MWParser.h"
#include <stdio.h>     
#include <stdlib.h>
#include <string>
#include "mwresult.h"


using namespace System;
using namespace System::Collections::Generic;
using namespace System::Runtime::InteropServices;
//using namespace System::Linq;
using namespace System::Text;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;
using namespace System::IO;

using namespace std;


/* Parser */
    /*
	 * MWPARSER_MASK - Set the desired parser type Available options:
	 * MWP_PARSER_MASK_AAMVA
	 * MWP_PARSER_MASK_GS1
	 * MWP_PARSER_MASK_HIBC
	 * MWP_PARSER_MASK_ISBT
	 * MWP_PARSER_MASK_IUID
	 * MWP_PARSER_MASK_SCM
	 * MWP_PARSER_MASK_NONE
	 */
const int MWPARSER_MASK = MWP_PARSER_MASK_NONE;
const bool USE_MWPARSER = false;


namespace MWBDemo
{
	class Program
	{


	


				//typedef int(__cdecl *MWBgetLibVersion)();
			//	__declspec(dllimport)int static MWBgetLibVersion();

	/*	[DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBgetLibVersion();
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBgetSupportedCodes();
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBsetScanningRect(int codeMask, float left, float top, float width, float height);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBregisterSDK_pchar(byte[] key);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBsetActiveCodes(int codeMask);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBsetActiveSubcodes(int codeMask, int subMask);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBcleanupLib();
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBgetLastType();
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBscanGrayscaleImage(byte[] gray, int width, int height, byte[] res);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBsetFlags(int codeMask, int flags);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBsetLevel(int level);
        [DllImport("BarcodeScanner.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int MWBsetDirection(int direction);*/


		
	};
}

cli::array<unsigned char, 1> ^ BitmapDataFromBitmap(Bitmap ^objBitmap)
{
	MemoryStream^ ms = gcnew MemoryStream();
	objBitmap->Save(ms, ImageFormat::Bmp);
	return (ms->GetBuffer());
}


int main(cli::array<System::String ^> ^args)
{

	int v = MWBgetLibVersion();

	// register your copy of the mobiScan SDK with the given key
	MWBregisterSDK_pchar("key");


	// choose code type or types you want to search for

	// Our sample app is configured by default to search all supported barcodes...
	MWBsetActiveCodes(	MWB_CODE_MASK_QR |
						MWB_CODE_MASK_DM |
						MWB_CODE_MASK_RSS |
						MWB_CODE_MASK_39  |
						MWB_CODE_MASK_EANUPC |
						MWB_CODE_MASK_128  |
						MWB_CODE_MASK_PDF |
						MWB_CODE_MASK_AZTEC |
						MWB_CODE_MASK_25 |
						MWB_CODE_MASK_93 |
						MWB_CODE_MASK_CODABAR |
						MWB_CODE_MASK_DOTCODE |
						MWB_CODE_MASK_11 |
						MWB_CODE_MASK_MSI |
						MWB_CODE_MASK_MAXICODE |
						MWB_CODE_MASK_POSTAL
					);

	

	// But for better performance, only activate the symbologies your application requires...
	// MWBsetActiveCodes( MWB_CODE_MASK_QR );
	// MWBsetActiveCodes( MWB_CODE_MASK_DM );
	// MWBsetActiveCodes( MWB_CODE_MASK_RSS );
	// MWBsetActiveCodes( MWB_CODE_MASK_39  );
	// MWBsetActiveCodes( MWB_CODE_MASK_EANUPC );
	// MWBsetActiveCodes( MWB_CODE_MASK_128  );
	// MWBsetActiveCodes( MWB_CODE_MASK_PDF );
	// MWBsetActiveCodes( MWB_CODE_MASK_AZTEC );
	// MWBsetActiveCodes( MWB_CODE_MASK_25 );
	// MWBsetActiveCodes( MWB_CODE_MASK_93 );
	// MWBsetActiveCodes( MWB_CODE_MASK_CODABAR );
	// MWBsetActiveCodes( MWB_CODE_MASK_DOTCODE );
	// MWBsetActiveCodes( MWB_CODE_MASK_11 );
	// MWBsetActiveCodes( MWB_CODE_MASK_MSI );
	// MWBsetActiveCodes( MWB_CODE_MASK_MAXICODE );
	// MWBsetActiveCodes( MWB_CODE_MASK_POSTAL );
	// MWBsetActiveCodes( MWB_CODE_MASK_ALL );

	// Enable verification for code93 barcode type
	// MWBsetParam(MWB_CODE_MASK_93, MWB_PAR_ID_VERIFY_LOCATION, MWB_PAR_VALUE_VERIFY_LOCATION_ON);

	// Our sample app is configured by default to search both directions...
	MWBsetDirection(MWB_SCANDIRECTION_OMNI);

	//MWBsetScanningRect(MWB_CODE_MASK_PDF, 0, 0, 100, 100);

	String ^filename = args[0];
	Bitmap ^objBitmap = gcnew Bitmap(filename);

	cli::array<unsigned char,1> ^BitmapData = BitmapDataFromBitmap(objBitmap);

	int width = objBitmap->Width;
	int height = objBitmap->Height;
	int size = width * height;
	unsigned char *gray; 

	//scale down image if resolution is too high
	if (objBitmap->Width > 2500 || objBitmap->Height > 2500) {
		width /= 2;
		height /= 2;
		size /= 4;
		gray = (unsigned char *)malloc(width * height);
		for (int x = 0; x < width; x++)
		{
			for (int y = 0; y < height; y++)
			{
				Color pixelColor = objBitmap->GetPixel(x * 2, y * 2);
				gray[width * y + x] = (uint8_t)(((int)pixelColor.R + (int)pixelColor.G + (int)pixelColor.B) / 3);
			}
		}
	}
	else {
		gray = (unsigned char *)malloc(width * height);
		for (int x = 0; x < objBitmap->Width; x++)
		{
			for (int y = 0; y < objBitmap->Height; y++)
			{
				Color pixelColor = objBitmap->GetPixel(x, y);
				gray[width * y + x] = (uint8_t)(((int)pixelColor.R + (int)pixelColor.G + (int)pixelColor.B) / 3);
			}
		}
	}

	

		// set decoder effort level (1 - 5)
		// for live scanning scenarios, a setting between 1 to 3 will suffice
		// levels 4 and 5 are typically reserved for batch scanning 
		MWBsetLevel(2);

		uint8_t *p_data = (uint8_t *)malloc(10000);

		MWBsetResultType(MWB_RESULT_TYPE_MW);
		int len = MWBscanGrayscaleImage(gray, width, height, p_data);

		if (len > 0){

			MWResults *mwres = new MWResults(p_data);
			MWResult *mwResult = NULL;
			if (mwres != NULL && mwres->getCount() > 0) {
				mwResult = mwres->getResults().back();

				/*just decoder w/out parser*/
				std::string resultText = "";

				resultText += "Barcode Type: " + mwResult->typeName + "\n Decoded Result: " + mwResult->text;
				
				Console::WriteLine( gcnew String( resultText.c_str()));

				/*with parser*/

				if (USE_MWPARSER && MWPARSER_MASK != MWP_PARSER_MASK_NONE)
				{
					uint8_t *pp_data = (uint8_t *)malloc(20000); memset(pp_data, 0, 20000);

					char* enc = mwResult->parserInput;
					int elen = strlen(enc);
				
					double fres = MWPgetJSON(MWPARSER_MASK, (uint8_t*)enc, elen, pp_data);
					//double fres = MWPgetFormattedText(MWPARSER_MASK, (uint8_t*)enc, elen, pp_data);

					String^ resultData = gcnew String((const char*)pp_data);
					Console::WriteLine( gcnew String( "\n Parsed Result: " + resultData ));

					free(pp_data);
				}
			}
			
			//std::string s(reinterpret_cast<char const*>(p_data), len);

			//String^ str = gcnew String(s.c_str());

		}

		free(p_data);


	free(gray);

   
    return 0;
}
